/*
 * GuessCategory.java
 *
 * Created on 8. december 2007, 22:12
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package webreader;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.LinkedList;

/**
 *
 * @author Rune
 */
public class GuessCategory {
    
    /** Creates a new instance of GuessCategory */
    private LinkedList<guess> guessList = new LinkedList<guess>();
    public int Matches = 0;
    public GuessCategory() {
    }
    
    public int ReadList(File inputFile) throws IOException{
        FileInputStream FIS = null;
        try {
            FIS = new FileInputStream(inputFile);
        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        }
        BufferedReader BFIS = new BufferedReader(new InputStreamReader(FIS));
        
        String inputLine;
        int lineCnt = 0;
        //System.out.println("Reading guess file");
        while( (inputLine = BFIS.readLine()) != null){
            lineCnt++;
            if(inputLine.indexOf('#')==-1){
                if(inputLine.length()>6){
                    guess gs = new guess();
                    int quotIndex[] = new int[4];
                    int prev=-1;
                    for(int i=0 ; i<quotIndex.length ; i++){
                        quotIndex[i] = inputLine.indexOf('"', prev+1);
                        //System.out.println("index " + quotIndex[i] + " " + prev);
                        prev=quotIndex[i];

                        if(quotIndex[i]==-1){
                            System.err.println("Error parsing guess-file. Missing \" at line " + lineCnt);
                        }
                    }
                    gs.text = inputLine.substring(quotIndex[0]+1, quotIndex[1]).toLowerCase();
                    gs.cat = inputLine.substring(quotIndex[2]+1, quotIndex[3]);
                    guessList.add(gs);
                    //System.out.println(gs.text + " " + gs.cat);
                }
            }
        }
        
        return guessList.size();
    }
    
    public String Match(String ProgramInfo){
        //System.out.println("matching");
        for(guess gs : guessList){
            if( (ProgramInfo.toLowerCase()).indexOf(gs.text) != -1){
                Matches++;
                //gs.matchCnt++;
                return gs.cat;
            }
        }
        return null;
    }
    
}
